明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1956|回复: 6

[讨论] 修改任意文字,为什么会改不了

[复制链接]
发表于 2011-7-24 17:01:00 | 显示全部楼层 |阅读模式
本帖最后由 tranney 于 2011-7-24 17:04 编辑

下列代码用起来蛮好的,就是改了标注的文字,移动标注的时候,标注文字会自动改回来,希望高手能帮忙改好一下,谢谢
(defun C:GZ (/ dcl_id1 oba ob1 obn obt ptn otxt txt sty styno lay cyn layno
        hig wid ang col cnu etlst style layer
     )
  (graphscr)
  (EF:UNDOBegin)
  (setq olderr *error*)
  (defun *error* (msg)
    (princ "\n*ERROR*...")
    (princ msg)
    (princ)
  )           ; end defun error.
  (defun set_color (conm / costr)
    (defun map_color (ckey mno)
      (start_image ckey)
      (fill_image 0 0 (DimX_tile ckey) (DimY_tile ckey) mno)
      (end_image)
    )           ; end defun
    (cond
      ((= 0 conm)
(setq costr "Byblock")
      )
      ((= 1 conm)
(setq costr "Red")
      )
      ((= 2 conm)
(setq costr "Yellow")
      )
      ((= 3 conm)
(setq costr "Green")
      )
      ((= 4 conm)
(setq costr "Cyan")
      )
      ((= 5 conm)
(setq costr "Bule")
      )
      ((= 6 conm)
(setq costr "Magenta")
      )
      ((= 7 conm)
(setq costr "color")
      )
      ((= 256 conm)
(setq costr "Bylayer")
      )
      (t
(setq costr "")
      )
    )           ; end cond
    (cond
      ((= 0 col)
(map_color "col" 7)
      )
      ((= 256 col)
(map_color "col" (cdr (assoc 62 (tblsearch "layer" lay))))
      )
      (t
(map_color "col" conm)
      )
    )           ; end cond
    (if (= 256 conm)
      (set_tile "cnu" (strcat "<" (itoa (cdr (assoc 62 (tblsearch "layer"
          lay
             )
          )
     )
      ) ">" costr
        )
      )
      (set_tile "cnu" (strcat "<" (itoa conm) ">" costr))
    )           ; end if

  )           ; end set_color
  (defun map_keylist (key keylst)      ; set popuplist
    (start_list key)
    (mapcar
      'add_list
      keylst
    )
    (end_list)
  )           ; end map
  (defun layer_get_all (/ lay layer layname)
    (setq layer nil         ; All layer
   lay (tblnext "LAYER" T)
    )
    (while (/= lay nil)
      (setq layname (cdr (assoc 2 lay))
     layer (cons layname layer)
      )
      (setq lay (tblnext "LAYER"))
    )
    (setq layer (ACAD_Strlsort layer))
    layer          ; all layer.

  )           ; end defun
  (defun style_get_all (/ sty style sty_list)
    (setq sty_list nil
   sty (tblnext "style" t)
    )
    (setq style (cdr (assoc 2 sty)))
    (while style
      (if (/= "" style)
(setq sty_list (append
    sty_list
    (list style)
         )
)
      )
      (setq sty (tblnext "style"))
      (setq style (cdr (assoc 2 sty)))
    )           ; end while]
    (setq sty_list (ACAD_Strlsort sty_list))
    sty_list
  )           ; end defun
  (defun set_error (str)
    (set_tile "error" str)
  )           ; end defun
  (defun sub_mtext (color entlist / ei newlist)
    (setq ei 0
   newlist nil
    )
    (while (< ei (length entlist))
      (setq newlist (cons (nth ei entlist) newlist))
      (if (= 8 (car (nth ei entlist)))
(setq newlist (cons (cons 62 color) newlist))
      )           ; end if
      (setq ei (1+ ei))
    )           ; end while
    (reverse newlist)
  )           ; end defun
  (setq ob1 (entsel "\n选择要修改的任何文本:"))
  (SETQ obn (car ob1)
ptn (car (cdr ob1))
  )
  (setq obt (car (nentselp ptn)))
  (setq oba (cdr (assoc 0 (entget obt))))
  (if (or
(= oba "TEXT")
(= oba "MTEXT")
(= oba "ATTRIB")
      )
    (setq otxt (cdr (assoc 1 (entget obt))))
  )           ; end if
  (if (= oba "ATTDEF")
    (setq otxt (cdr (assoc 2 (entget obt))))
  )           ; end if
  (if otxt
    (progn
      (setq sty (cdr (assoc 7 (entget obt)))
     lay (cdr (assoc 8 (entget obn)))
     hig (cdr (assoc 40 (entget obt)))
     wid (cdr (assoc 41 (entget obt)))
     ang (cdr (assoc 50 (entget obt)))
      )           ; end setq
      (if (or
     (= oba "TEXT")
     (= oba "MTEXT")
     (= oba "ATTRIB")
   )
(setq col (cdr (assoc 62 (entget obt))))
(setq col (cdr (assoc 62 (entget obn))))
      )           ; end if
      (setq ang (* 180 (/ ang pi)))
      (if (null col)
(progn
   (setq cyn 0)
   (setq col 256)
)
(setq cyn 1)
      )
      (setq style (style_get_all))
      (setq layer (layer_get_all))
      (setq styno (- (length style) (length (member sty style))))
      (setq layno (- (length layer) (length (member lay layer))))
(setq dclname
(cond  
((setq tempname (vl-filename-mktemp "tt-dcl-tmp.dcl") filen (open tempname "w"))
(foreach stream  
'(  
"\n"
"文字修改:dialog {\n"
" label = \"文字编辑...\";\n"
" : boxed_radio_column {\n"
"  label = \"超级文字编辑...\";\n"
"  : edit_box {\n"
"   label= \"文字:\";\n"
"   key = \"text\";\n"
"   edit_width = 50;\n"
"  }\n"
"  : row {\n"
"   : popup_list {\n"
"    label=\"样式\";\n"
"    key = \"sty\";\n"
"    edit_width = 13;\n"
"    fixed_width = true;\n"
"   }\n"
"   : edit_box {\n"
"    label=\"高度\";\n"
"    key = \"hig\";\n"
"    edit_width = 7;\n"
"    fixed_width = true;\n"
"   }\n"
"   : edit_box {\n"
"    label=\"宽度\";\n"
"    key = \"wid\";\n"
"    edit_width = 7;\n"
"    fixed_width = true;\n"
"   }\n"
"  }\n"
"  : row {\n"
"   : popup_list {\n"
"    label=\"图层\";\n"
"    key = \"lay\";\n"
"    edit_width = 13;\n"
"    fixed_width = true;\n"
"   }\n"
"   : image_button {\n"
"    key = \"col\";\n"
"    width= 4;\n"
"    aspect_ratio = 0.75;\n"
"    fixed_width = true;\n"
"   }\n"
"   : text_part {\n"
"    key = \"cnu\";\n"
"    width= 12;\n"
"    fixed_width = true;\n"
"   }\n"
"   : edit_box {\n"
"    label=\"角度\";\n"
"    key = \"ang\";\n"
"    edit_width = 7;\n"
"    fixed_width = true;\n"
"   }\n"
"  }\n"
"  spacer_1;\n"
" }\n"
" : row {\n"
"  alignment = right;\n"
"  : spacer {\n"
"   width = 1;\n"
"   fixed_width = true;\n"
"   }\n"
"  ok_cancel;\n"
" }\n"
" errtile;\n"
"}\n"
)
(princ stream filen)
)
(close filen)
tempname
)))
      (setq dcl_id1 (load_dialog dclname))
      (if (not (new_dialog "文字修改" dcl_id1))
(exit)
      )
      (set_color col)
      (set_tile "text" otxt)
      (set_tile "hig" (rtos hig 2 2))
      (set_tile "wid" (rtos wid 2 2))
      (set_tile "ang" (rtos ang 2 2))
      (mode_tile "text" 2)
      (map_keylist "sty" style)
      (set_tile "sty" (itoa styno))
      (map_keylist "lay" layer)
      (set_tile "lay" (itoa layno))
      (action_tile "text" "(setq txt $value)")
      (action_tile "sty" "(setq styno (atoi $value))")
      (action_tile "hig" "(setq hig (distof $value))(if (>= 0 hig)(progn (mode_tile \"hig\" 3)(mode_tile \"hig\" 2)(set_error \"Input error ! \"))(set_error \"\"))")
      (action_tile "wid" "(setq wid (distof $value))(if (>= 0 wid)(progn (mode_tile \"wid\" 3)(mode_tile \"wid\" 2)(set_error \"Input error ! \"))(set_error \"\"))")
      (action_tile "lay" "(setq layno (atoi $value))")
      (action_tile "col" "(if (setq cnu (ACAD_ColorDlg col))(progn (setq col cnu)(set_color col)))")
      (action_tile "ang" "(setq ang (distof $value))")
      (action_tile "accept" "(done_dialog 1)")
      (action_tile "cancel" "(done_dialog 0)")
      (if (= 1 (start_dialog))
(if txt
   (progn
     (setq sty (nth styno style))
     (setq lay (nth layno layer))
     (setq ang (* (/ ang 180) pi))
     (setq etlst (entget obt))
     (if (= oba "ATTDEF")
       (setq etlst (subst
       (cons 2 txt)
       (assoc 2 etlst)
       etlst
     )
       )
       (setq etlst (subst
       (cons 1 txt)
       (assoc 1 etlst)
       etlst
     )
       )
     ); end if
     (setq etlst (subst
     (cons 7 sty)
     (assoc 7 etlst)
     etlst
   )
     )
     (setq etlst (subst
     (cons 40 hig)
     (assoc 40 etlst)
     etlst
   )
     )
     (setq etlst (subst
     (cons 41 wid)
     (assoc 41 etlst)
     etlst
   )
     )
     (setq etlst (subst
     (cons 50 ang)
     (assoc 50 etlst)
     etlst
   )
     )
     (if (= 1 cyn)
       (setq etlst (subst
       (cons 62 col)
       (assoc 62 etlst)
       etlst
     )
       )
       (if (= "MTEXT" oba)
  (setq etlst (sub_mtext col etlst))
  (setq etlst (cons (cons 62 col) etlst))
       )          ; end if
     )          ; end if
     (entmod etlst)
     (entupd obt)
     (entupd obn)
   )
)          ; end if
      )           ; end if
      (if (= 11 (start_dialog))
(Command "_help")
      )
    )           ; end progn
  )           ; end if
  (setq *error* olderr)
  (EF:UNDOEnd)
  (princ)
  (unload_dialog dcl_id1)
  (vl-file-delete dclname)
)
;;; end defun
;;***********修改任意文字;完成


"觉得好,就打赏"
还没有人打赏,支持一下
发表于 2011-7-25 09:00:13 | 显示全部楼层
EF:UNDOBegin函数未定义。
发表于 2011-7-25 09:35:49 | 显示全部楼层
修改尺寸标注的,“特性”或 DDEdit 命令不都可以吗?这个程序修改的是尺寸标注相应块定义里尺寸文字实体 MTEXT 里的文字内容,不是尺寸定义里的;尺寸定义里的定义依然是 <> 这样的缺省值,所以一旦尺寸标注有变化,就会引发其重生成,将文字更新到实际的测量值。
发表于 2013-3-16 16:49:38 | 显示全部楼层
这个代码很是实用,就是尺寸移动的问题,希望好心人顶力相助能帮忙改一下,好让这么好的的代码更据实用性,解救更多人,你的大德大家都会记在心里。谢谢了
发表于 2013-3-21 14:41:26 | 显示全部楼层
本帖最后由 xiaxiang 于 2013-3-21 15:38 编辑

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x

点评

块文字修改不了  发表于 2013-8-30 17:30
发表于 2013-3-22 17:44:39 | 显示全部楼层
太感谢xiaxiang的无私!!!..解救了好多人.....

评分

参与人数 1金钱 +6 收起 理由
tranney + 6 谢谢大佬~~很喜欢

查看全部评分

 楼主| 发表于 2013-6-4 15:51:42 | 显示全部楼层
晕死,居然没币了,哈哈谢谢大佬~~很喜欢
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-24 14:19 , Processed in 0.200826 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表